#include "plc_vars.h"
#include "common_def.h"

const uint64_t retain_unique_id = 0x62376361UL;

#define _PLC_VAR_RETAIN_UNIQUE_ID \
_PLC_VAR_DEF(retain_unique_id,alias_retain_unique_id,_DIRECT,NONRETAIN,NO_TAG) \

#define _PLC_VAR_LIST \
_PLC_VAR_DEF(GLOBAL_VAR(default_resource,A1),default_resource_A1,_LOCATED(M,W,2052),NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(GLOBAL_VAR(default_resource,A2),default_resource_A2,_LOCATED(M,W,2053),NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(GLOBAL_VAR(default_resource,A3),default_resource_A3,_LOCATED(M,W,2054),NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(GLOBAL_VAR(default_resource,A4),default_resource_A4,_LOCATED(M,W,2055),NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(GLOBAL_VAR(default_resource,A5),default_resource_A5,_LOCATED(M,W,2056),NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(GLOBAL_VAR(default_resource,A6),default_resource_A6,_LOCATED(M,W,2057),NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(GLOBAL_VAR(default_resource,A7),default_resource_A7,_LOCATED(M,W,2058),NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(GLOBAL_VAR(default_resource,A8),default_resource_A8,_LOCATED(M,W,2059),NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(GLOBAL_VAR(default_resource,A9),default_resource_A9,_LOCATED(M,W,2060),NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(GLOBAL_VAR(default_resource,A10),default_resource_A10,_LOCATED(M,W,2061),NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(GLOBAL_VAR(default_resource,B1),default_resource_B1,_LOCATED(M,X,4096,0),NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(GLOBAL_VAR(default_resource,B2),default_resource_B2,_LOCATED(M,X,4096,1),NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(GLOBAL_VAR(default_resource,B3),default_resource_B3,_LOCATED(M,X,4096,2),NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(GLOBAL_VAR(default_resource,B4),default_resource_B4,_LOCATED(M,X,4096,3),NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(GLOBAL_VAR(default_resource,B5),default_resource_B5,_LOCATED(M,X,4096,4),NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(GLOBAL_VAR(default_resource,B6),default_resource_B6,_LOCATED(M,X,4096,5),NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(GLOBAL_VAR(default_resource,B7),default_resource_B7,_LOCATED(M,X,4096,6),NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(GLOBAL_VAR(default_resource,B8),default_resource_B8,_LOCATED(M,X,4096,7),NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(GLOBAL_VAR(default_resource,B9),default_resource_B9,_LOCATED(M,X,4097,0),NONRETAIN,NO_TAG) \
_PLC_VAR_DEF(GLOBAL_VAR(default_resource,B10),default_resource_B10,_LOCATED(M,X,4097,1),NONRETAIN,NO_TAG) \


#define _PLC_VAR_DEF(Var,Alias,Locate,Retain,Tag)   Alias,
enum PlcVarIndex
{
    _PLC_VAR_LIST
    kNumOfPlcVarIndex
};
#undef _PLC_VAR_DEF

#define _PLC_VAR_DEF(Var,Alias,Locate,Retain,Tag) _MONITOR_VAR(Var,Locate)
const MonitorVarDesc var_list[] = 
{
    _PLC_VAR_LIST
};
const uint32_t var_list_size = sizeof(var_list)/sizeof(var_list[0]);
#undef _PLC_VAR_DEF

#define _PLC_VAR_DEF(Var,Alias,Locate,Retain,Tag)   _RETAN_VAR(Alias,Retain)
const RetainVarDesc retain_list[] = 
{
    _PLC_VAR_RETAIN_UNIQUE_ID
    _PLC_VAR_LIST
};
const uint32_t retain_list_size = sizeof(retain_list)/sizeof(retain_list[0]);
#undef _PLC_VAR_DEF

#define _PLC_VAR_DEF(Var,Alias,Locate,Retain,Tag)   _TAG_VAR(Alias,Tag)
const TagVarDesc tag_list[] = 
{
    _PLC_VAR_LIST
};
const uint32_t tag_list_size = sizeof(tag_list)/sizeof(tag_list[0]);
#undef _PLC_VAR_DEF

